#lang at-exp racket
(require infix plot)

(parameterize (
               [plot-width    250]
               [plot-height   250]
               [plot-x-label  #f]
               [plot-y-label  #f])

  (define r 20)
  (define R (* r 3))

  (define (hypocycloid phi)
    @${vector[
       (R-r)*cos[phi] + r*cos[(R-r)/r * phi],
       (R-r)*sin[phi] - r*sin[(R-r)/r * phi]]})

  (plot (list
         (parametric (λ (t) @${vector[R*cos[t], R*sin[t]]})
                     0 (* r 2 pi)
                     #:color "black"
                     #:width 2)
         (parametric hypocycloid
                     0 (* r 2 pi)
                     #:color "red"
                     #:width 2))
        #:x-min (- -10 R ) #:x-max (+ 10 R )
        #:y-min (- -10 R ) #:y-max (+ 10 R )
        #:x-label #f #:y-label #f
        )
  )