#lang racket
(require racklog)

; Each person can have from one to six doughnuts.
(define %can-have
  (%rel (d)
        [(d) (%member d '(1 2 3 4 5 6))]))

; an alias for equality
(define %has (%rel (n) [(n n)]))

; if a person doesn't have d donuts, they have n donuts
(define %not-have
  (%rel (n d)
        [(n d)
         (%can-have n)
         (%=/= n d)]))

; In the following, the identifier with the person's
; name represents the number of doughnuts that the
; person had.

(define %statement
  (%rel (Jack Janet Chris)
        
        ; Jack's statements
        [('jack Jack Janet)
            (%has Janet 2) (%has Jack 1)]
        [('jack Jack Janet)
            (%not-have Janet 2) (%not-have Jack 1)]

        ; Janet's statements
        [('janet Jack Janet)
            (%has Janet 2) (%has Jack 2)]
        [('janet Jack Janet)
            (%not-have Janet 2) (%not-have Jack 2)]

        ; Chris's statements
        [('chris Jack Janet)
            (%has Janet 2) (%can-have Jack) (%> Jack 3)]
        [('chris Jack Janet)
            (%not-have Janet 2) (%can-have Jack) (%<= Jack 3)]))

(define %solve
  (%rel (Jack Janet Chris)
        [(Jack Janet Chris)
            (%statement 'jack Jack Janet)
            (%statement 'janet Jack Janet)
            (%statement 'chris Jack Janet)
            (%can-have Chris)
            (%is 6 (+ Jack Janet Chris))]))
        
